
/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) The Santa Cruz Operation, 1985, 1986.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 *
 */


/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */



/*
 * Declaration of block device switch. Each entry (row) is
 * the only link between the main unix code and the driver.
 * The initialization of the device switches is in the file conf.c.
 */
extern struct bdevsw
{
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_strategy)();
	struct iobuf *d_tab;
} bdevsw[];

/*
 * Character device switch.
 */
extern struct cdevsw
{
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_read)();
	int	(*d_write)();
	int	(*d_ioctl)();
	struct tty	*d_ttys;
} cdevsw[];

/*
 * Line discipline switch.
 */
extern struct linesw
{
	int	(*l_open)();
	int	(*l_close)();
	int	(*l_read)();
	int	(*l_write)();
	int	(*l_ioctl)();
	int	(*l_input)();
	int	(*l_output)();
	int	(*l_mdmint)();
} linesw[];

extern	int	linecnt;

/*
 * Terminal switch.
 */
extern struct termsw
{
	int	(*t_input)();
	int	(*t_output)();
	int	(*t_ioctl)();
} termsw[];

extern	int	termcnt;

extern	int	(*vecintsw[])();
extern	uchar_t	vecintflags[];
extern	uchar_t	vecintlev[];
/*
 * Definitions for vecintflags in c.c:
 * info about vectors contained in vecintsw.
 */
#define SWITCH_INTR	0
#define FAST_INTR	1
#define	CLOCK_INTR	2

extern	int		bdevcnt, bdevmax;
extern	int		cdevcnt, cdevmax;

extern			nodev( ), nulldev( ), novec( );

extern	int		(*dinitsw[])();

#ifdef IDD

extern	int		(*binitsw[])(), (*cinitsw[])();
struct vecshrsw {
	int		shr_ivec;		/* interrupt level */
	int		(*shr_intr)( );		/* ptr to xxintr */
};
extern	struct vecshrsw	vecshrsw[];
extern	int		vshrcnt, vshrmax;
extern	int		vintmin, vintmax;
extern			shrvec( );

#include "idd.h"

extern	struct iddsw	far *iddsw[];
extern	int		iddcnt, iddmax;

#endif
