/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) The Santa Cruz Operation, 1985, 1986.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 *
 */

/*
 *	User level include file for: 
 *	PC Console keyboard related defines and variables.
 *
 */

#define NUM_ASCII	256	/* Number of ascii characters */

#define NUM_KEYS	111	/* Max number of possible physical keys */
#define NUM_STATES	  8	/* Number of key states */

/* defines for the function key configuring with ESC Q .... */
#define FKEYSTART	0	/* The F1 key is string key #0 */
#define NFKEYS		60	/* There are sixty function keys */

#define NSTRKEYS	 60	/* max number of string (function) keys */
#define STRTABLN	256	/* max length of the sum of all strings */

#define GIO_COLOR  ('c'<<8)	/* Ioctl for present color card status */
#define GIO_ATTR   ('a'<<8)	/* Ioctl for present char mode */

#define MIOC	('m'<<8)

#define GIO_KEYMAP	(MIOC|0)	/* Get keyboard map table */
#define PIO_KEYMAP	(MIOC|1)	/* Put keyboard map table */

#define GIO_SCRNMAP	(MIOC|2)	/* Get screen output map table */
#define PIO_SCRNMAP	(MIOC|3)	/* Put screen output map table */

#define GIO_STRMAP	(MIOC|4)	/* Get function key string table */
#define PIO_STRMAP	(MIOC|5)	/* Put function key string table */

typedef unsigned char keymap_t[NUM_KEYS+1][NUM_STATES];
typedef unsigned char scrnmap_t[NUM_ASCII];
typedef unsigned char strmap_t[STRTABLN];

#define NORMAL	0
#define SHIFT	1
#define CTRL	2
#define	SHFCTL	3
#define ALT	4
#define	ALTSHF	5
#define	ALTCTL	6
#define	ALTSHFCTL	7

#define K_INV		0377	/* Invalid key from key table */

/***************** Special number pad keys ***********************/

#define IS_NUMPAD(x)    ( ((x) >= 71) && ((x) <= 83) )

/***************** Special range macros and keys *****************/

#define SPECKEY	0200	/* codes with this bit set are special */
#define	IS_SPECIAL(x)	((x) & SPECKEY)

#define K_RSH	0200	/* Right shift */
#define K_CTL	0201	/* Control */
#define K_CLK	0202	/* Caps lock */
#define K_LSH	0203	/* Left shift */
#define K_ALT	0204	/* Alt */
#define K_NLK	0205	/* Num lock */
#define K_SLK	0206	/* Scroll lock */
#define	K_BTAB	0207	/* Back tab */
#define K_NXSC	0210	/* Switch to next screen */
#define K_SC	0220	/* Switch to screen 1 */
#define K_SCN	0237	/* Switch to screen N */

/***************** Expanded string range keys and macros *****************/

#define STRKEYLO	0300	/* codes starting here are string keys */
#define	STRKEYHI	(STRKEYLO + NSTRKEYS - 1)
#define IS_STRKEY(x)	( ((x) >= STRKEYLO) && ((x) <= STRKEYHI) )

