/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) The Santa Cruz Operation, 1985, 1986.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 *
 */

/*
 * THIS FILE CONTAINS CODE SPECIFIC TO THE GENERIC 286
 * COMPUTER. IT MAY REQUIRE MODIFICATION WHEN MOVING
 * XENIX TO DIFFERENT MACHINE ARCHITECTURES OR CONFIGURATIONS.
 */

/*
 *	Various machine dependent things
 */


/* Cga adapter control */
#define	CGAIO	('C' << 8)	
#define	CGAMODE (CGAIO | 1)		/* change cga mode */

/* Pga adapter control */
#define PGAIO	('P' << 8)
#define PGAMODE (PGAIO | 1)		/* change pga mode */

/* Ega adapter control */
#define EGAIO	('E' << 8)
#define EGAMODE (EGAIO | 1)		/* change ega mode */

/* Common adapter control */

#include "comcrt.h"

/* Defines for console-switching ioctl -- MONO, CGA, PGA, and EGA */
/* definitions are in comcrt.h  				  */	
#define SWAPCONS ('s' << 8)
#define SWAPMONO (SWAPCONS | MONO)
#define SWAPCGA  (SWAPCONS | CGA)
#define SWAPPGA  (SWAPCONS | PGA)
#define SWAPEGA  (SWAPCONS | EGA)

/* defines for mode-switching ioctl -- modes are defined in comcrt.h */
#define MODESWITCH ('S' << 8)
#define SW_B40x25  (MODESWITCH | M_B40x25)
#define SW_C40x25  (MODESWITCH | M_C40x25)
#define SW_B80x25  (MODESWITCH | M_B80x25)
#define SW_C80x25  (MODESWITCH | M_C80x25)
#define SW_BG320   (MODESWITCH | M_BG320)
#define SW_CG320   (MODESWITCH | M_CG320)
#define SW_BG640   (MODESWITCH | M_BG640)
#define SW_EGAMONO80x25 (MODESWITCH | M_EGAMONO80x25)
#define SW_ENHB40x25  (MODESWITCH | M_ENH_B40x25)
#define SW_ENHC40x25  (MODESWITCH | M_ENH_C40x25)
#define SW_ENHB80x25  (MODESWITCH | M_ENH_B80x25)
#define SW_ENHC80x25  (MODESWITCH | M_ENH_C80x25)

/* defines for display memory mapping ioctl (see consioctl in console.c) */
#define MAPADAPTER ('m' << 8)
#define MAPCONS (MAPADAPTER)  
#define MAPMONO (MAPADAPTER | MONO)
#define MAPCGA  (MAPADAPTER | CGA) 
#define MAPPGA  (MAPADAPTER | PGA)
#define MAPEGA  (MAPADAPTER | EGA)


/*
 *  Number of GDT entries. This value must be at least 24. 
 *  Descriptor table entries 25 through NGDT are allocated to drivers as 
 *  needed by means of the dscralloc  and dscrfree routines.
 */
#define NGDT	(30 + 10 + 10)	/* +10 for MultiScreens, +10 more for OEM's */

/*
 * Initalize clock constant for 20msec clock interrupts.
 * Magic value to cause proper interrupt interval - used
 * by mdep/mch.s/clkinit().
 * Assumes a 1.193181MHz clock input. (1193181 / HZ)
 */
#define CLKNUM 23864

/*
 * Max number of PICs to deal with.
 */
#define	NUM_8259	2


#define	HAS_REBOOT	/* This system has a software reboot capability */

#define CTLR_16BIT	/* This system has a device controller that cannot */
		   	/* handle transfers across a 64k boundary. */

#define AUTOBOOT	/* This system has autoboot support */
