/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) The Santa Cruz Operation, 1985, 1986.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 *
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286/8086 CPU AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/*
 * PLB	3-11-83
 * Index of the users' stored
 * registers relative to AX.
 * Usage is u.u_ar0[XX].
 * EVERYTHING HERE IS DEPENDENT ON trap: in mch.s and trap.c
 * AND THE HARDWARE
 */

/*
 * users regs on kernel stack i80286 kernel.
 */
#define	RSS	7		/* user ss */
#define	RSP	6		/* user sp */
#define USP	6
#define	RFL	5
#define	RCS	4
#define	RIP	3
#define	Rviol	2
#define	RES	1
#define	RAX	0
#define	RCX	-1
#define	RDX	-2
#define	RBX	-3
#define	RKSP	-4		/* NOT sp to user's stack */
#define	RBP	-5
#define	RSI	-6
#define	RDI	-7
#define	RDS	-8


/* These values are for the i8086 kernel */

#define URFLAG  12      /* these guys are in the user data space,       */
#define URCS    10      /* and are read by fuword(u.u_aAX[RSP] + URxx)  */
#define URIP     8
#define URVEC    6
#define URBP     4
#define URES     2
#define URDX     0

#define RSP86     8	/* these guys are on system stack */
#define USP86     8
#define RSS86     7
#define RDS86     5
#define RDI86     4
#define RSI86     3
#define RCX86     2
#define RBX86     1
#define RAX86     0
#define Rstate  -1              /* user/system mode, trap # */
#define Rilev   -2              /* interrupted procedure level */

/* these values are generic across both cpu's */

#define CBIT    0x001           /* 8086 'C' bit in flags     */
#define ZBIT    0x040           /* 8086 'Z' bit in flags     */
#define TBIT    0x100           /* 8086 trace bit in 'flags' */
#define IBIT    0x200           /* 8086 interrupt enable bit */
#define OBIT    0x800           /* 8086 overflow bit in 'flags' */
