/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) The Santa Cruz Operation, 1985, 1986.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 *
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286 CPU AND THE INTEL 8086 CPU AND MAY REQUIRE
 * MODIFICATION WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

typedef	struct { int r[1]; }	*physadr;
typedef	long		daddr_t;
typedef	char		*caddr_t;
typedef	unsigned short	ushort;
typedef	unsigned short	ino_t;
typedef	char		cnt_t;
typedef	long	time_t;
typedef	int		label_t[6];	/* return, sp, si, di, bp */
typedef	short		dev_t;
typedef	long		off_t;
typedef	unsigned long	paddr_t;
typedef	unsigned short	mloc_t;		/* memory region location */
typedef	unsigned short	msize_t;	/* memory region size */
typedef unsigned long	key_t;		/* IPC key	      */
typedef unsigned 	uint;

/* 80286 and 8086 special types */

#ifdef M_I286
#define	faddr_t		char far *		/* far address */
#define	fdesc_t		struct desctab far	/* far ldt entry */
#endif

#ifdef M_I86
#define	faddr_t		char *			/* pseudo far address */
#define laddr_t		char far *
#endif

/* selectors and constructor for device code */
#ifndef major
#define major(x)        (((unsigned)(x)>>8))
#endif
#ifndef minor
#define minor(x)        ((x)&0377)
#endif
#ifndef makedev
#define makedev(x,y)	(dev_t)((x)<<8 | (y))
#endif

/* 'void' type compatibility */
#ifdef	M_OLDVOID
typedef	int	void;
#endif

/* 'unsigned' type compatibility */
#ifdef	M_OLDSIGN	/* { */

typedef	char	uchar_t;
typedef	long	ulong_t;

#define	GETUCHAR(uc)	(0xff & (uc))		/* extract value */
/* WARNING: you will lose the high bit */
#define	GETULONG(ul)	(0x7fffffffL & (ul))	/* extract value */

#else			/* }{ */

typedef unsigned char uchar_t;
typedef unsigned long ulong_t;
#define	GETUCHAR(uc)	(uc)
#define	GETULONG(ul)	(ul)

#endif			/* } */

struct saddr {			
	unsigned short	sa_seg;
	long		sa_off;
};
